#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_RankPointParam.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_RankPointParam> Fish_RankPointParam::msSingleton(nullptr);

int Fish_RankPointParam::GetCount()
{
	return (int)mMapData.size();
}

const Fish_RankPointParamData* Fish_RankPointParam::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_RankPointParamData>& Fish_RankPointParam::GetMapData()
{
	return mMapData;
}

void Fish_RankPointParam::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_RankPointParam::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_RankPointParamData data;
		data.mID = element->IntAttribute("ID");
		data.mRoomID = element->IntAttribute("RoomID");
		data.mRankType = element->IntAttribute("RankType");
		data.mType = element->IntAttribute("Type");
		data.mThresholds = element->IntAttribute("Thresholds");
		data.maddition = element->IntAttribute("addition");
		data.mMax = element->IntAttribute("Max");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_RankPointParam::Load()
{
	Load("../Config/Fish_RankPointParam.xml");
}

Fish_RankPointParam* Fish_RankPointParam::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_RankPointParam());
	}
	return msSingleton.get();
}
